//////////////////////////////////////////////////////////////////////////////
// Le Her (Simplified Version)
//
// This applet implements the Le Her game in its simplified version.
//
// Humberto Jos Bortolossi, Brgida Alexandre Sartini and Gilmar Garbugio.
//
// Last update: 15/01/2007
//////////////////////////////////////////////////////////////////////////////

import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.GridLayout;
import java.awt.Image;
import java.awt.Insets;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.lang.String;
import java.net.URL;
import javax.swing.BorderFactory;
import javax.swing.JApplet;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.Timer;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;

public class LeHer1 extends JApplet implements ActionListener
{
    protected int language = 1;
    protected JPanel panel;
    protected String[] deck_trans = {"Cartas", "Cards"};
    protected JPanel deck_panel;

    protected String[] start_trans = {"Reiniciar!", "Reset!"};
    protected JButton start_btn;

    protected DrawingPanel X_panel;
    protected DrawingPanel Y_panel;
    protected DrawingPanel Z_panel;

    protected Image X_img;
    protected Image Y_img;
    protected Image Z_img;

    protected Image D_01_img;
    protected Image D_02_img;
    protected Image D_03_img;
    protected Image D_04_img;
    protected Image D_05_img;
    protected Image D_06_img;
    protected Image D_07_img;
    protected Image D_08_img;
    protected Image D_09_img;
    protected Image D_10_img;
    protected Image D_11_img;
    protected Image D_12_img;
    protected Image D_13_img;
    protected Image[] D_img;
    protected String[] D_txt = {null, " A", " 2", " 3", " 4", " 5", " 6", " 7",
                                      " 8", " 9", "10", " Q", " J", " K"};
    protected Font text_fnt = new Font("Courier", Font.PLAIN, 11);
    protected String[] score_trans = {"Placar", "Score"};
    protected JPanel score_panel;

    protected String[] computer_trans = {"Computador: ", "Computer: "};
    protected String[] you_trans = {"Voc:       ", "You:      "};
    protected int computer_score = 0;
    protected int you_score = 0;
    protected JLabel computer_lbl;
    protected JLabel you_lbl;

    protected int X_val;
    protected int Y_val;
    protected int Z_val;

    protected int[] deck = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12};

    protected String[] play_trans = {"Jogar!", "Play!"};
    protected String[] play_again_trans = {"Jogar novamente!", "Play again!"};
    protected JButton play_btn;

    protected String[] go_trans = {"Pressione o boto acima para jogar!",
                                   "Press the button above to play!"};
    protected String[] shuffle_trans = {"Embaralhando ...", "Shuffling ..."};
    protected String[] y_card_trans = {"Sua carta Y  ", "Your card Y is "};
    protected String[] p1k_trans = {"O computador vai manter sua carta X.",
                                    "The computer will keep its card X."};
    protected String[] p1s_trans = {"O computador est trocando de carta com voc.",
                                    "The computer is swapping its card with you."};
    protected String[] p2d_trans = {"O que voc vai fazer?", "What you gonna do?"};
    protected String[] p1w_trans = {"O computador ganhou!", "The computer wins!"};
    protected String[] p2w_trans = {"Voc ganhou!", "You win!"};
    protected JLabel msg_lbl;

    protected JPanel action_panel;
    protected JLabel ex_lbl;
    protected String[] sc_trans = {"Vou trocar Y com Z!", "I'll Swap Y with Z!"};
    protected String[] kc_trans = {"Vou manter Y!", "I'll keep Y!"};
    protected JButton sc_btn;
    protected JButton kc_btn;

    protected Timer timer1;
    protected Timer timer2;
    protected Timer timer3;
    protected Timer timer4;
    protected ActionListener action1;
    protected ActionListener action2;
    protected ActionListener action3;
    protected ActionListener action4;

    public void init()
    {
        super.init();

	// Set up language
	language = Integer.valueOf(getParameter("idiom")).intValue();

        // Main panel
        panel = new JPanel();
        // panel.setBackground(Color.BLUE);
        this.getContentPane().add(panel);
        GridBagLayout gblm = new GridBagLayout();
        panel.setLayout(gblm);
        panel.setBorder(BorderFactory.createEtchedBorder());

        // Start button
        start_btn = new JButton(start_trans[language]);
        start_btn.addActionListener(this);
        GridBagConstraints gbc01 = new GridBagConstraints();
        gbc01.fill = GridBagConstraints.NONE;
        gbc01.gridx = 0;
        gbc01.gridy = 0;
        gbc01.gridwidth = 1;
        gbc01.gridheight = 1;
        gblm.setConstraints(start_btn, gbc01);
        panel.add(start_btn);

        // Separator
        JLabel sep1 = new JLabel(" ");
        GridBagConstraints gbc02 = new GridBagConstraints();
        gbc02.fill = GridBagConstraints.NONE;
        gbc02.gridx = 0;
        gbc02.gridy = 1;
        gbc02.gridwidth = 1;
        gbc02.gridheight = 1;
        gblm.setConstraints(sep1, gbc02);
        panel.add(sep1);

        // Deck card panels
        deck_panel = new JPanel();
        GridBagLayout gbld = new GridBagLayout();
        deck_panel.setLayout(gbld);
        TitledBorder title;
        title = BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED), deck_trans[language]);
        title.setTitleJustification(TitledBorder.LEFT);
        deck_panel.setBorder(title);

        GridBagConstraints gbc03 = new GridBagConstraints();
        gbc03.fill = GridBagConstraints.HORIZONTAL;
        gbc03.gridx = 0;
        gbc03.gridy = 2;
        gbc03.gridwidth = 1;
        gbc03.gridheight = 1;
        gblm.setConstraints(deck_panel, gbc03);
        panel.add(deck_panel);

        X_panel = new DrawingPanel();
        X_panel.setPreferredSize(new Dimension(71, 96));
        URL X_url = LeHer1.class.getResource("/cards/" + "xdeck.gif");
        X_img = Toolkit.getDefaultToolkit().getImage(X_url);
        while (X_img.getHeight(this) == -1)
        {
            // Empty!
            // This is set to wait complete load of the image!
        }
        X_panel.setImage(X_img);
        X_panel.update(X_panel.getGraphics());
        GridBagConstraints gbcdx = new GridBagConstraints();
        gbcdx.insets = new Insets(5, 20, 10, 5);
        gbcdx.gridx = 0;
        gbcdx.gridy = 0;
        gbcdx.gridwidth = 1;
        gbcdx.gridheight = 1;
        gbld.setConstraints(X_panel, gbcdx);
        deck_panel.add(X_panel);

        Y_panel = new DrawingPanel();
        Y_panel.setPreferredSize(new Dimension(71, 96));
        URL Y_url = LeHer1.class.getResource("/cards/" + "ydeck.gif");
        Y_img = Toolkit.getDefaultToolkit().getImage(Y_url);
        while (Y_img.getHeight(this) == -1)
        {
            // Empty!
            // This is set to wait complete load of the image!
        }
        Y_panel.setImage(Y_img);
        Y_panel.update(Y_panel.getGraphics());
        GridBagConstraints gbcdy = new GridBagConstraints();
        gbcdy.insets = new Insets(5, 5, 10, 5);
        gbcdy.gridx = 1;
        gbcdy.gridy = 0;
        gbcdy.gridwidth = 1;
        gbcdy.gridheight = 1;
        gbld.setConstraints(Y_panel, gbcdy);
        deck_panel.add(Y_panel);

        Z_panel = new DrawingPanel();
        Z_panel.setPreferredSize(new Dimension(71, 96));
        URL Z_url = LeHer1.class.getResource("/cards/" + "zdeck.gif");
        Z_img = Toolkit.getDefaultToolkit().getImage(Z_url);
        while (Z_img.getHeight(this) == -1)
        {
            // Empty!
            // This is set to wait complete load of the image!
        }
        Z_panel.setImage(Z_img);
        Z_panel.update(Z_panel.getGraphics());
        GridBagConstraints gbcdz = new GridBagConstraints();
        gbcdz.insets = new Insets(5, 5, 10, 20);
        gbcdz.gridx = 2;
        gbcdz.gridy = 0;
        gbcdz.gridwidth = 1;
        gbcdz.gridheight = 1;
        gbld.setConstraints(Z_panel, gbcdz);
        deck_panel.add(Z_panel);

        // Deck images
        {
            URL D_01_url = LeHer1.class.getResource("/cards/" + "01.gif");
            D_01_img = Toolkit.getDefaultToolkit().getImage(D_01_url);
            while (D_01_img.getHeight(this) == -1)
            {
                // Empty!
                // This is set to wait complete load of the image!
            }
        }

        {
            URL D_02_url = LeHer1.class.getResource("/cards/" + "02.gif");
            D_02_img = Toolkit.getDefaultToolkit().getImage(D_02_url);
            while (D_02_img.getHeight(this) == -1)
            {
                // Empty!
                // This is set to wait complete load of the image!
            }
        }

        {
            URL D_03_url = LeHer1.class.getResource("/cards/" + "03.gif");
            D_03_img = Toolkit.getDefaultToolkit().getImage(D_03_url);
            while (D_03_img.getHeight(this) == -1)
            {
                // Empty!
                // This is set to wait complete load of the image!
            }
        }

        {
            URL D_04_url = LeHer1.class.getResource("/cards/" + "04.gif");
            D_04_img = Toolkit.getDefaultToolkit().getImage(D_04_url);
            while (D_04_img.getHeight(this) == -1)
            {
                // Empty!
                // This is set to wait complete load of the image!
            }
        }

        {
            URL D_05_url = LeHer1.class.getResource("/cards/" + "05.gif");
            D_05_img = Toolkit.getDefaultToolkit().getImage(D_05_url);
            while (D_05_img.getHeight(this) == -1)
            {
                // Empty!
                // This is set to wait complete load of the image!
            }
        }

        {
            URL D_06_url = LeHer1.class.getResource("/cards/" + "06.gif");
            D_06_img = Toolkit.getDefaultToolkit().getImage(D_06_url);
            while (D_06_img.getHeight(this) == -1)
            {
                // Empty!
                // This is set to wait complete load of the image!
            }
        }

        {
            URL D_07_url = LeHer1.class.getResource("/cards/" + "07.gif");
            D_07_img = Toolkit.getDefaultToolkit().getImage(D_07_url);
            while (D_07_img.getHeight(this) == -1)
            {
                // Empty!
                // This is set to wait complete load of the image!
            }
        }

        {
            URL D_08_url = LeHer1.class.getResource("/cards/" + "08.gif");
            D_08_img = Toolkit.getDefaultToolkit().getImage(D_08_url);
            while (D_08_img.getHeight(this) == -1)
            {
                // Empty!
                // This is set to wait complete load of the image!
            }
        }

        {
            URL D_09_url = LeHer1.class.getResource("/cards/" + "09.gif");
            D_09_img = Toolkit.getDefaultToolkit().getImage(D_09_url);
            while (D_09_img.getHeight(this) == -1)
            {
                // Empty!
                // This is set to wait complete load of the image!
            }
        }

        {
            URL D_10_url = LeHer1.class.getResource("/cards/" + "10.gif");
            D_10_img = Toolkit.getDefaultToolkit().getImage(D_10_url);
            while (D_10_img.getHeight(this) == -1)
            {
                // Empty!
                // This is set to wait complete load of the image!
            }
        }

        {
            URL D_11_url = LeHer1.class.getResource("/cards/" + "11.gif");
            D_11_img = Toolkit.getDefaultToolkit().getImage(D_11_url);
            while (D_11_img.getHeight(this) == -1)
            {
                // Empty!
                // This is set to wait complete load of the image!
            }
        }

        {
            URL D_12_url = LeHer1.class.getResource("/cards/" + "12.gif");
            D_12_img = Toolkit.getDefaultToolkit().getImage(D_12_url);
            while (D_12_img.getHeight(this) == -1)
            {
                // Empty!
                // This is set to wait complete load of the image!
            }
        }

        {
            URL D_13_url = LeHer1.class.getResource("/cards/" + "13.gif");
            D_13_img = Toolkit.getDefaultToolkit().getImage(D_13_url);
            while (D_13_img.getHeight(this) == -1)
            {
                // Empty!
                // This is set to wait complete load of the image!
            }
        }

        // Separator
        JLabel sep2 = new JLabel(" ");
        GridBagConstraints gbc04 = new GridBagConstraints();
        gbc04.fill = GridBagConstraints.NONE;
        gbc04.gridx = 0;
        gbc04.gridy = 3;
        gbc04.gridwidth = 1;
        gbc04.gridheight = 1;
        gblm.setConstraints(sep2, gbc04);
        panel.add(sep2);

        // Score
        score_panel = new JPanel();
        GridBagLayout gbls = new GridBagLayout();
        score_panel.setLayout(gbls);
        title = BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED), score_trans[language]);
        title.setTitleJustification(TitledBorder.LEFT);
        score_panel.setBorder(title);

        GridBagConstraints gbc05 = new GridBagConstraints();
        gbc05.fill = GridBagConstraints.HORIZONTAL;
        gbc05.gridx = 0;
        gbc05.gridy = 4;
        gbc05.gridwidth = 1;
        gbc05.gridheight = 1;
        gblm.setConstraints(score_panel, gbc05);
        panel.add(score_panel);

        computer_lbl = new JLabel(cs());
        computer_lbl.setFont(text_fnt);
        GridBagConstraints gbcsc = new GridBagConstraints();
        gbcsc.fill = GridBagConstraints.NONE;
        gbcsc.insets = new Insets(5, 20, 10, 20);
        gbcsc.gridx = 0;
        gbcsc.gridy = 0;
        gbcsc.gridwidth = 1;
        gbcsc.gridheight = 1;
        gbls.setConstraints(computer_lbl, gbcsc);
        score_panel.add(computer_lbl);

        you_lbl = new JLabel(ys());
        you_lbl.setFont(text_fnt);
        GridBagConstraints gbcsy = new GridBagConstraints();
        gbcsy.fill = GridBagConstraints.NONE;
        gbcsy.insets = new Insets(5, 20, 10, 20);
        gbcsy.gridx = 1;
        gbcsy.gridy = 0;
        gbcsy.gridwidth = 1;
        gbcsy.gridheight = 1;
        gbls.setConstraints(you_lbl, gbcsy);
        score_panel.add(you_lbl);

        // Separator
        JLabel sep3 = new JLabel(" ");
        GridBagConstraints gbc06 = new GridBagConstraints();
        gbc06.fill = GridBagConstraints.NONE;
        gbc06.gridx = 0;
        gbc06.gridy = 5;
        gbc06.gridwidth = 1;
        gbc06.gridheight = 1;
        gblm.setConstraints(sep3, gbc06);
        panel.add(sep3);

        // Play Button
        play_btn = new JButton(play_trans[language]);
        play_btn.addActionListener(this);
        GridBagConstraints gbc07 = new GridBagConstraints();
        gbc07.fill = GridBagConstraints.NONE;
        gbc07.gridx = 0;
        gbc07.gridy = 6;
        gbc07.gridwidth = 1;
        gbc07.gridheight = 1;
        gblm.setConstraints(play_btn, gbc07);
        panel.add(play_btn);

        // Separator
        JLabel sep4 = new JLabel(" ");
        GridBagConstraints gbc08 = new GridBagConstraints();
        gbc08.fill = GridBagConstraints.NONE;
        gbc08.gridx = 0;
        gbc08.gridy = 7;
        gbc08.gridwidth = 1;
        gbc08.gridheight = 1;
        gblm.setConstraints(sep4, gbc08);
        panel.add(sep4);

        // Message
        msg_lbl = new JLabel(go_trans[language]);
        GridBagConstraints gbc09 = new GridBagConstraints();
        gbc09.fill = GridBagConstraints.NONE;
        gbc09.gridx = 0;
        gbc09.gridy = 8;
        gbc09.gridwidth = 1;
        gbc09.gridheight = 1;
        gblm.setConstraints(msg_lbl, gbc09);
        panel.add(msg_lbl);

        // Separator
        JLabel sep5 = new JLabel(" ");
        GridBagConstraints gbc10 = new GridBagConstraints();
        gbc10.fill = GridBagConstraints.NONE;
        gbc10.gridx = 0;
        gbc10.gridy = 9;
        gbc10.gridwidth = 1;
        gbc10.gridheight = 1;
        gblm.setConstraints(sep5, gbc10);
        panel.add(sep5);

        // What to do?
        action_panel = new JPanel();
        action_panel.setLayout(new GridLayout(1, 3));
        GridBagConstraints gbc11 = new GridBagConstraints();
        gbc11.fill = GridBagConstraints.NONE;
        gbc11.gridx = 0;
        gbc11.gridy = 10;
        gbc11.gridwidth = 1;
        gbc11.gridheight = 1;
        gblm.setConstraints(action_panel, gbc11);
        panel.add(action_panel);

        sc_btn = new JButton(sc_trans[language]);
        sc_btn.setEnabled(false);
        sc_btn.addActionListener(this);
        action_panel.add(sc_btn);
        ex_lbl = new JLabel("   ");
        action_panel.add(ex_lbl);
        kc_btn = new JButton(kc_trans[language]);
        action_panel.add(kc_btn);
        kc_btn.setEnabled(false);
        kc_btn.addActionListener(this);

        // D_img array
        D_img = new Image[14];
        D_img[ 0] = null;
        D_img[ 1] = D_01_img;
        D_img[ 2] = D_02_img;
        D_img[ 3] = D_03_img;
        D_img[ 4] = D_04_img;
        D_img[ 5] = D_05_img;
        D_img[ 6] = D_06_img;
        D_img[ 7] = D_07_img;
        D_img[ 8] = D_08_img;
        D_img[ 9] = D_09_img;
        D_img[10] = D_10_img;
        D_img[11] = D_11_img;
        D_img[12] = D_12_img;
        D_img[13] = D_13_img;
    }

    public void actionPerformed(ActionEvent event)
    {
        Object source = event.getSource();
        if (source == start_btn)
        {
            X_panel.setImage(X_img);
            X_panel.update(X_panel.getGraphics());
            Y_panel.setImage(Y_img);
            Y_panel.update(Y_panel.getGraphics());
            Z_panel.setImage(Z_img);
            Z_panel.update(Z_panel.getGraphics());
            computer_score = 0;
            you_score = 0;
            computer_lbl.setText(cs());
            you_lbl.setText(ys());
            play_btn.setText(play_trans[language]);

            shuffle();

            X_val = deck[0] + 1;
            Y_val = deck[1] + 1;
            Z_val = deck[2] + 1;

            msg_lbl.setText(go_trans[language]);
            play_btn.setEnabled(true);
            sc_btn.setEnabled(false);
            kc_btn.setEnabled(false);
        }

        if (source == play_btn)
        {
            start_btn.setEnabled(false);
            play_btn.setEnabled(false);
            X_panel.setImage(X_img);
            X_panel.update(X_panel.getGraphics());
            Y_panel.setImage(Y_img);
            Y_panel.update(Y_panel.getGraphics());
            Z_panel.setImage(Z_img);
            Z_panel.update(Z_panel.getGraphics());

            msg_lbl.setText(shuffle_trans[language]);

            // X keeps its card
            action4 = new ActionListener()
            {
                public void actionPerformed(java.awt.event.ActionEvent e)
                {
                    msg_lbl.setText(p2d_trans[language]);
                    Toolkit.getDefaultToolkit().beep();
                    timer4.stop();
                    sc_btn.setEnabled(true);
                    sc_btn.setText(sc_trans[language]);
                    kc_btn.setEnabled(true);
                    kc_btn.setText(kc_trans[language]);
                }
            };

            // X sweeps its card with Y
            action3 = new ActionListener()
            {
                public void actionPerformed(java.awt.event.ActionEvent e)
                {
                    Y_panel.setImage(D_img[X_val]);
                    Y_panel.update(Y_panel.getGraphics());
                    X_panel.setImage(D_img[Y_val]);
                    X_panel.update(X_panel.getGraphics());

                    msg_lbl.setText(p2d_trans[language]);
                    Toolkit.getDefaultToolkit().beep();
                    int temp = X_val;
                    X_val = Y_val;
                    Y_val = temp;
                    timer3.stop();
                    sc_btn.setEnabled(true);
                    sc_btn.setText(sc_trans[language]);
                    kc_btn.setEnabled(true);
                    kc_btn.setText(kc_trans[language]);
                }
            };

            action2 = new ActionListener()
            {
                public void actionPerformed(java.awt.event.ActionEvent e)
                {
                    if (X_val <= 7)
                    {
                        msg_lbl.setText(p1s_trans[language]);
                        X_panel.setImage(D_img[X_val]);
                        X_panel.update(X_panel.getGraphics());
                        timer2.stop();
                        timer3 = new Timer(3000, action3);
                        timer3.start();
                    }
                    else
                    {
                        if (X_val >= 10)
                        {
                            msg_lbl.setText(p1k_trans[language]);
                            timer2.stop();
                            timer4 = new Timer(3000, action4);
                            timer4.start();
                        }
                        else
                        {
                            int s = 8;
                            do
                            {
                                s = ((int) Math.random() * 6) + 1;
                            } while ((s < 1) && (s > 7));
                            if (s <= 6)
                            {
                                msg_lbl.setText(p1k_trans[language]);
                                timer2.stop();
                                timer4 = new Timer(3000, action4);
                                timer4.start();
                            }
                            else
                            {
                                if (X_val == 9)
                                {
                                    msg_lbl.setText(p1k_trans[language]);
                                    timer2.stop();
                                    timer4 = new Timer(3000, action4);
                                    timer4.start();
                                }
                                else
                                {
                                    msg_lbl.setText(p1s_trans[language]);
                                    X_panel.setImage(D_img[X_val]);
                                    X_panel.update(X_panel.getGraphics());
                                    timer2.stop();
                                    timer3 = new Timer(3000, action3);
                                    timer3.start();
                                }
                            }
                        }
                    }
                }
            };

            action1 = new ActionListener()
            {
                public void actionPerformed(java.awt.event.ActionEvent e)
                {
                    shuffle();

                    X_val = deck[0] + 1;
                    Y_val = deck[1] + 1;
                    Z_val = deck[2] + 1;

                    msg_lbl.setText(y_card_trans[language] + D_txt[Y_val] + ".");
                    Y_panel.setImage(D_img[Y_val]);
                    Y_panel.update(Y_panel.getGraphics());

                    timer1.stop();
                    timer2 = new Timer(3000, action2);
                    timer2.start();
                }
            };
            timer1 = new Timer(1500, action1);
            timer1.start();
        }

        if (source == this.kc_btn)
        {
           X_panel.setImage(D_img[X_val]);
           X_panel.update(X_panel.getGraphics());
           Y_panel.setImage(D_img[Y_val]);
           Y_panel.update(Y_panel.getGraphics());
           Z_panel.setImage(D_img[Z_val]);
           Z_panel.update(Z_panel.getGraphics());
           if (X_val > Y_val)
           {
               msg_lbl.setText(p1w_trans[language]);
               computer_score++;
               computer_lbl.setText(cs());
           }
           else
           {
               msg_lbl.setText(p2w_trans[language]);
               you_score++;
               you_lbl.setText(ys());
           }
           sc_btn.setEnabled(false);
           kc_btn.setEnabled(false);
           play_btn.setEnabled(true);
           start_btn.setEnabled(true);
        }

        if (source == this.sc_btn)
        {
           X_panel.setImage(D_img[X_val]);
           X_panel.update(X_panel.getGraphics());
           Y_panel.setImage(D_img[Y_val]);
           Y_panel.update(Y_panel.getGraphics());
           Z_panel.setImage(D_img[Z_val]);
           Z_panel.update(Z_panel.getGraphics());
           if (X_val > Z_val)
           {
               msg_lbl.setText(p1w_trans[language]);
               computer_score++;
               computer_lbl.setText(cs());
           }
           else
           {
               msg_lbl.setText(p2w_trans[language]);
               you_score++;
               you_lbl.setText(ys());
           }
           sc_btn.setEnabled(false);
           kc_btn.setEnabled(false);
           play_btn.setEnabled(true);
           start_btn.setEnabled(true);
        }
    }

    protected String cs()
    {
       String s = computer_trans[language];

       if (computer_score < 10)
       {
           s = s + "  ";
       }
       else
       {
           if (computer_score < 100)
           {
               s = s + " ";
           }
       }

       return(s + Integer.toString(computer_score));
    }

    protected String ys()
    {
       String s = you_trans[language];

       if (you_score < 10)
       {
           s = s + "  ";
       }
       else
       {
           if (you_score < 100)
           {
               s = s + " ";
           }
       }

       return(s + Integer.toString(you_score));
    }

    protected void shuffle()
    {
        for (int i = 0; i <= 12; i++)
        {
           deck[i] = i;
        }

        for (int i = 12; i > 0; i-- )
        {
            int rand = (int)(Math.random()*(i + 1));
            int temp = deck[i];
            deck[i] = deck[rand];
            deck[rand] = temp;
        }
    }
}

class DrawingPanel extends JPanel
{
    protected Image img = null;
    int img_w;
    int img_h;

    void DrawingPanel()
    {
       img = null;
       img_w = img_h = -1;
    }

    void setImage(Image image)
    {
       img =  image;

       img_w = img.getWidth(this);
       img_h = img.getHeight(this);
       this.setPreferredSize(new Dimension(img_w, img_h));
   }

   protected void paintComponent(Graphics g)
   {
       super.paintComponent(g);
       Graphics2D g2d = (Graphics2D)g.create();
       g2d.drawImage(img, 0, 0, this.getWidth(), this.getHeight(), null);
       g2d.dispose();
   }
}
