//////////////////////////////////////////////////////////////////////////////
// Le Her (Simplified Version)
//
// This applet computes an entry of the payoff matrix generating all
// possibilities.
//
// Humberto Jos Bortolossi, Brgida Alexandre Sartini and Gilmar Garbugio.
//
// Last update: 15/01/2007
//////////////////////////////////////////////////////////////////////////////

import java.applet.Applet;
import java.awt.Button;
import java.awt.Choice;
import java.awt.Font;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextArea;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.lang.String;

public class LeHer2 extends Applet implements ActionListener
{
   protected String p1s = "Jogador 1 mantm carta maior do que ou igual a:";
   protected Label p1l;
   protected Choice p1k; // Player 1 keeps the card if its value is
                         // greater than or equal to p1k.
   protected String p2s = "Jogador 2 mantm carta maior do que ou igual a:";
   protected Label p2l;
   protected Choice p2k; // Player 2 keeps the card if its value is
                         // greater than or equal to p2k.
   protected String gos = "Calcular!";
   protected Button gob;
   protected Label frl;
   protected TextArea lhi;
   protected int noc = 13;
   protected int nop = noc*(noc - 1)*(noc - 2);
   protected int nov;
   protected String[] cards = {" 0", " A", " 2", " 3", " 4", " 5", " 6", " 7",
                               " 8", " 9", "10", " Q", " J", " K"};

   public void init()
   {
       super.init();


       p1l = new Label(p1s, Label.LEFT);
       p1k = new Choice();
       p1k.add(" A");
       p1k.add(" 2");
       p1k.add(" 3");
       p1k.add(" 4");
       p1k.add(" 5");
       p1k.add(" 6");
       p1k.add(" 7");
       p1k.add(" 8");
       p1k.add(" 9");
       p1k.add("10");
       p1k.add(" Q");
       p1k.add(" J");
       p1k.add(" K");

       p2l = new Label(p2s, Label.LEFT);
       p2k = new Choice();
       p2k.add(" A");
       p2k.add(" 2");
       p2k.add(" 3");
       p2k.add(" 4");
       p2k.add(" 5");
       p2k.add(" 6");
       p2k.add(" 7");
       p2k.add(" 8");
       p2k.add(" 9");
       p2k.add("10");
       p2k.add(" Q");
       p2k.add(" J");
       p2k.add(" K");

       Panel panel = new Panel();
       this.add(panel);

       GridBagLayout gblm = new GridBagLayout();
       panel.setLayout(gblm);

       // Player 1
       GridBagConstraints gbc1 = new GridBagConstraints();
       gbc1.fill = GridBagConstraints.NONE;
       gbc1.anchor = GridBagConstraints.LINE_START;
       gbc1.gridx = 0;
       gbc1.gridy = 0;
       gbc1.gridwidth = 1;
       gbc1.gridheight = 1;
       gbc1.weightx = 1.0;
       gblm.setConstraints(p1l, gbc1);
       panel.add(p1l);

       GridBagConstraints gbc2 = new GridBagConstraints();
       gbc2.fill = GridBagConstraints.HORIZONTAL;
       gbc2.gridx = 1;
       gbc2.gridy = 0;
       gbc2.gridwidth = 1;
       gbc2.gridheight = 1;
       gblm.setConstraints(p1k, gbc2);
       panel.add(p1k);

       // Player 2
       GridBagConstraints gbc3 = new GridBagConstraints();
       gbc3.fill = GridBagConstraints.NONE;
       gbc3.anchor = GridBagConstraints.LINE_START;
       gbc3.gridx = 0;
       gbc3.gridy = 1;
       gbc3.gridwidth = 1;
       gbc3.gridheight = 1;
       gbc3.weightx = 1.0;
       gblm.setConstraints(p2l, gbc3);
       panel.add(p2l);

       GridBagConstraints gbc4 = new GridBagConstraints();
       gbc4.fill = GridBagConstraints.NONE;
       gbc4.gridx = 1;
       gbc4.gridy = 1;
       gbc4.gridwidth = 1;
       gbc4.gridheight = 1;
       gblm.setConstraints(p2k, gbc4);
       panel.add(p2k);

       // Separator
       Label sp1 = new Label("");
       GridBagConstraints gbc5 = new GridBagConstraints();
       gbc5.fill = GridBagConstraints.NONE;
       gbc5.gridx = 0;
       gbc5.gridy = 2;
       gbc5.gridwidth = 2;
       gbc5.gridheight = 1;
       gblm.setConstraints(sp1, gbc5);
       panel.add(sp1);

       // Button
       gob = new Button(gos);
       GridBagConstraints gbc6 = new GridBagConstraints();
       gbc6.fill = GridBagConstraints.NONE;
       gbc6.gridx = 0;
       gbc6.gridy = 3;
       gbc6.gridwidth = 2;
       gbc6.gridheight = 1;
       gblm.setConstraints(gob, gbc6);
       panel.add(gob);
       gob.addActionListener(this);

       // Separator
       Label sp2 = new Label("");
       GridBagConstraints gbc7 = new GridBagConstraints();
       gbc7.fill = GridBagConstraints.NONE;
       gbc7.gridx = 0;
       gbc7.gridy = 4;
       gbc7.gridwidth = 2;
       gbc7.gridheight = 1;
       gblm.setConstraints(sp2, gbc7);
       panel.add(sp2);

       // Final result label
       frl = new Label(" ", Label.CENTER);
       GridBagConstraints gbc8 = new GridBagConstraints();
       gbc8.fill = GridBagConstraints.HORIZONTAL;
       gbc8.gridx = 0;
       gbc8.gridy = 5;
       gbc8.gridwidth = 2;
       gbc8.gridheight = 1;
       gblm.setConstraints(frl, gbc8);
       panel.add(frl);

       // TextArea
       lhi = new TextArea(" ", 22, 64);
       lhi.setEditable(false);
       lhi.setFont(new Font("Courier", Font.PLAIN, 11));
       GridBagConstraints gbc9 = new GridBagConstraints();
       gbc9.fill = GridBagConstraints.NONE;
       gbc9.gridx = 0;
       gbc9.gridy = 6;
       gbc9.gridwidth = 2;
       gbc9.gridheight = 1;
       gblm.setConstraints(lhi, gbc9);
       panel.add(lhi);
   }

   protected int s2c(String s)
   {
       if (s.equals(" A"))
       {
           return(1);
       }
       if (s.equals(" Q"))
       {
           return(11);
       }
       if (s.equals(" J"))
       {
           return(12);
       }
       if (s.equals(" K"))
       {
           return(13);
       }
       s.trim();
       return(Integer.valueOf(s).intValue());
   }

   public void actionPerformed(ActionEvent event)
   {
       Object source = event.getSource();
       if (source == gob)
       {
           int k1v = p1k.getSelectedIndex() + 1;
           int k2v = p2k.getSelectedIndex() + 1;
           nov = 0;
           lhi.setText("");
           int x;
           int y;
           int z;
           int a;
           String m;
	   gob.setEnabled(false);
           for (int i = 1; i <= noc; i++)
           {
               for (int j = 1; j <= noc; j++)
               {
                   if (j != i)
                   {
                       for (int k = 1; k <= noc; k++)
                       {
                           if ((k != i) && (k != j))
                           {
                               m = "";
                               lhi.append("X = " + cards[i] + ",   " +
                                          "Y = " + cards[j] + ",   " +
                                          "Z = " + cards[k]);

                               x = i;
                               y = j;
                               z = k;

                               if (x < k1v)
                               {
                                   m = m + ",   (1 T";
                                   a = x;
                                   x = y;
                                   y = a;
                                   if (x > y)
                                   {
                                       m = m + ", 2 T)";
                                       a = y;
                                       y = z;
                                       z = a;
                                   }
                                   else
                                   {
                                       m = m + ", 2 M)";
                                   }
                               }
                               else
                               {
                                   m = m + ",   (1 M";
                                   if (y < k2v)
                                   {
                                       m = m + ", 2 T)";
                                       a = y;
                                       y = z;
                                       z = a;
                                   }
                                   else
                                   {
                                       m = m + ", 2 M)";
                                   }
                               }
                               if (x > y)
                               {
                                   m = m + "   ==>   1 ganhou!\n";
                                   nov++;
                                   frl.setText("Calculando: jogador 1 tem " +
                                               nov + " vitrias no total de " +
                                               nop + " possibilidades!");
                               }
                               else
                               {
                                   m = m + "\n";
                               }
                               lhi.append(m);
                           }
                       }
                   }
               }
           }
           m = "Probabilidade do jogador 1 ganhar = " + nov + "/" + nop +
               " = " + Math.ceil(((float) nov)/((float) nop)*1000)/1000 + "...";
           frl.setText(m);
	   gob.setEnabled(true);
       }
   }
}
